
#import "GrabBag.h"
#import "nxlcau6h.h"
#import <string.h>

#import "rec.h"
#import "rectbl.h"

/* To get REC to work (part 6): 24 */
extern Inst  rprg[PLEN]; 		/* rec program array */
extern struct fptbl dtbl[]; 		/* rec operators & predicates */
extern char idef[][30];			/* initially //defined o & p's */ 
extern char cstr[CLEN]; 		/* console rec program */
int    phil;				/* length of cstr	   */
extern char recrule[NY][CLEN];
extern char revrule[48][CLEN];




/* definiciones para el resto de programas GragBag  */
/* ya las tenia el Dr en su archivo */

extern  int binrule[KK][KK];

char   va[KK] = {'p', 'q', 'r', 's', 't', 'u'};

void asctobin();
int  eq01(int i, int j);
int  eq02(int i, int j);
int  eq03(int i, int j);
int  frac1(int a);
int  rec(char *z);
 

int  rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
int  rec_x(Inst rprg);

/*
void runowows(char x[2][2][2], int n);
int  wolbin(int a, int b);
int  wowsruno(char ru[2][2][2]);
void wru(char *c);*/




@implementation GrabBag

/* ------------ */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - -   O R D E R   R E L A T I O N S   - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* - showSubText: (char *)ch
{int tl;
  tl=[subText textLength];
  [subText setSel: tl: tl];
  [subText replaceSel:  ch];
  [subText scrollSelToVisible];
  [subText display];
return self;
} */

/* check the indices for all the subsets */
/* - subAut:sender
{
asctobin();
  [self showSubText: "Subset indices:\n\n"];
  [self showSubText: "(012)27/27\n\n"];
  [self twos];
  [self showSubText: "\n"];
  [self ones];
printf("goodbye from subAut\n");
return self;
  }*/

/* check the two-element subsets */
/* - twos 
{
char ch[30];
int  k, l, frac2(), wolbin();

  k=wolbin(0,1);
  l= frac2(0,1);
  if (k<256) sprintf(ch,"(01)   %2d/ 8  %3d\n",l,k);
        else sprintf(ch,"(01)   %2d/ 8\n",l); 
  [self showSubText: ch];

  k=wolbin(0,2);
  l= frac2(0,2);
  if (k<256) sprintf(ch,"(02)   %2d/ 8  %3d\n",l,k);
        else sprintf(ch,"(02)   %2d/ 8\n",l); 
  [self showSubText: ch];

  k=wolbin(1,2);
  l= frac2(1,2);
  if (k<256) sprintf(ch,"(12)   %2d/ 8  %3d\n",l,k);
        else sprintf(ch,"(12)   %2d/ 8\n",l); 
  [self showSubText: ch];

return self;
} */

/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular two element subset and report this as an index */

/* int frac2(a,b) int a, b; {int k, i0, i1, i2, s[2], isab();
k=0; s[0]=a; s[1]=b;
for (i0=0; i0<2; i0++)
for (i1=0; i1<2; i1++)
for (i2=0; i2<2; i2++)
  if (isab(a,b,binrule[s[i0]][s[i1]][s[i2]])) k++;
return k;
} */

/* check membership in two-element set */
/* int isab(a,b,i) int a, b, i; {return (i==a||i==b);} */

/* check whether one-element subset is closed */
/* - ones
{
char ch[20];
int  frac1();
sprintf(ch,"(0)    %2d/ 1\n",frac1(0)); [self showSubText: ch];
sprintf(ch,"(1)    %2d/ 1\n",frac1(1)); [self showSubText: ch];
sprintf(ch,"(2)    %2d/ 1\n",frac1(2)); [self showSubText: ch];
return self;
} */
 
/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular one element subset and report this as an index */
/* int frac1(a) int a; {int k; k=0; if (a==binrule[a][a][a]) k++; return k;} */

/* ascertain the Wolfram Rule Number of a two-state subautomaton */

/* int wolbin(a,b) int a, b; {
char ru[2][2][2];
int  k, i0, i1, i2, s[2], eq[KK], isab();
s[0]=a; s[1]=b;
eq[a]='0'; eq[b]='1';
for (i0=0; i0<2; i0++)
for (i1=0; i1<2; i1++)
for (i2=0; i2<2; i2++) {
  k=binrule[s[i0]][s[i1]][s[i2]];
  if (k==a || k==b) ru[i0][i1][i2]=eq[k]; else return 256;
  }
return wowsruno(ru);
} */

/* turn two-state ascrule into its two-state Wolfram number */
/* int wowsruno(ru) char ru[2][2][2]; {
int  k, i0, i1, i2;
  k=0;
  for (i0=1; i0>=0; i0--)
  for (i1=1; i1>=0; i1--)
  for (i2=1; i2>=0; i2--) {
    k=2*k+ru[i0][i1][i2]-'0';
    }
  return k;
} */

/* turn two-state Wolfram number into 2x2x2 ascrule */
/* void runowows(x,n) char x[2][2][2]; int n; {
int i, i0, i1, i2;
  i=n;
  for (i0=0; i0<2; i0++) 
  for (i1=0; i1<2; i1++) 
  for (i2=0; i2<2; i2++) {
    x[i0][i1][i2]=i%2+'0';
    i/=2;
    }
} */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - -   E Q U I V A L E N C E   R E L A T I O N S   - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* - showEquText: (char *)ch
{int tl;
  tl=[equText textLength];
  [equText setSel: tl: tl];
  [equText replaceSel:  ch];
  [equText scrollSelToVisible];
  [equText display];
return self;
} */

/* calculate equivalence relation indices */

/* - equAut:sender
{
char   ch[20];
int    i, j, i0, i1, i2, i3, i4, i5, q[5], t[5];
double r[5];
asctobin();
for (i=0; i<5; i++) q[i]=t[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  i=binrule[i0][i1][i2];
  j=binrule[i3][i4][i5];
  q[0]++;
  if (eq01(i0,i3)&&eq01(i1,i4)&&eq01(i2,i5)) {t[1]++; if (eq01(i,j)) q[1]++;}
  if (eq02(i0,i3)&&eq02(i1,i4)&&eq02(i2,i5)) {t[2]++; if (eq02(i,j)) q[2]++;}
  if (eq03(i0,i3)&&eq03(i1,i4)&&eq03(i2,i5)) {t[3]++; if (eq03(i,j)) q[3]++;}
  q[4]++;
  }
r[0]=1.0;
for (i=1; i<4; i++) r[i]=((double)q[i])/((double)t[i]);
r[4]=1.0;
		       [self showEquText:"Equivalence indices\n"];
sprintf(ch,"(012)       %5.3f\n",r[0]); [self showEquText: ch];
sprintf(ch,"(0)(12)     %5.3f\n",r[1]); [self showEquText: ch];
sprintf(ch,"(1)(02)     %5.3f\n",r[2]); [self showEquText: ch];
sprintf(ch,"(2)(01)     %5.3f\n",r[3]); [self showEquText: ch];
sprintf(ch,"(0)(1)(2)   %5.3f\n",r[4]); [self showEquText: ch];
printf("goodbye from equAut\n");
return self;
}

int eq01(i,j) int i, j; {return ((i==0&&j==0)||(i!=0&&j!=0));}
int eq02(i,j) int i, j; {return ((i==1&&j==1)||(i!=1&&j!=1));}
int eq03(i,j) int i, j; {return ((i==2&&j==2)||(i!=2&&j!=2));} */

/* ------------- */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - -   G E N E R A T E   M A T H E M A T I C A   I N T E R F A C E S   - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- matica:sender 
{
char ch[60];
int  tl, gbns;
int  i, j, k, i0, i1, i2, i3, i4, i5, i6, w[KK];
int  c[KK][KK+1][KK+1][KK+1][KK+1][KK+1];
  gbns=0;
  if (strcmp([sender title],"Groebner Basis")==0) gbns=YES;
  if (strcmp([sender title],"NSolve")==0)         gbns=NO;
// ++++++++++++++++++++++++++++++++ //
  wru(ch);
  [ruleNumber setStringValue: ch];
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK+1; i1++) for (i2=0; i2<KK+1; i2++) 
for (i3=0; i3<KK+1; i3++) for (i4=0; i4<KK+1; i4++) for (i5=0; i5<KK+1; i5++)
	c[i0][i1][i2][i3][i4][i5]=0;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  w[0]=w[1]=w[2]=w[3]=w[4]=w[5]=0;
  w[i0]++; w[i1]++; 
  (c[binrule[i0][i1]][w[0]][w[1]][w[2]][w[3]][w[4]])++;
  }

if (gbns) sprintf(ch,"GroebnerBasis[{\n"); else sprintf(ch,"NSolve[{\n");
  tl=[groeText textLength];
  [groeText setSel: 0: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];
for (i=0; i<KK; i++) {
  k=0;
  for (i1=0; i1<KK+1; i1++) for (i2=0; i2<KK+1; i2++)
  for (i3=0; i3<KK+1; i3++) for (i4=0; i4<KK+1; i4++)
  for (i5=0; i5<KK+1; i5++) {
    if (2 < i1+i2+i3+i4+i4) continue;
    j=c[i][i1][i2][i3][i4][i5];
    if (j == 0) continue;
    if (k > 0) {
	 sprintf(ch," + ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (j > 1) {
	 sprintf(ch,"%d " ,j);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i1==1) {
	 sprintf(ch,"p ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i1 > 1) {
	 sprintf(ch,"p^%d ",i1);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i2==1) {
	 sprintf(ch,"q ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i2 > 1) {
	 sprintf(ch,"q^%d ",i2);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }

     if (i3==1) {
	 sprintf(ch,"r ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i3 > 1) {
	 sprintf(ch,"r^%d ",i3);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
      if (i4==1) {
	 sprintf(ch,"s ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i4 > 1) {
	 sprintf(ch,"s^%d ",i4);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
     if (i5==1) {
	 sprintf(ch,"t ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i5 > 1) {
	 sprintf(ch,"t^%d ",i5);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }




    i6=2-i1-i2-i3-i4+i5;
    if (i6==1) {
	 sprintf(ch,"u ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i6 > 1) {
	 sprintf(ch,"u^%d ",i6);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    k++;
    }
  if (gbns) sprintf(ch," - %c,\n",va[i]);
	 else sprintf(ch," - %c == 0,\n",va[i]);
  tl=[groeText textLength];
  [groeText setSel: tl: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];
  } 
if (gbns) sprintf(ch,"p + q + r + s + t + u - 1\n},{p, q, r, s, t}]\n");
	else sprintf(ch,"p + q + r + s + t + u - 1 == 0\n},{p, q, r, s, t}]\n");
  tl=[groeText textLength];
  [groeText setSel: tl: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display]; 

// ++++++++++++++++++++++++++++++++ //

return self;
} 

/* --------------------- B R O W S E R   D E L E G A T E ------------------- */


- (int)browser: sender fillMatrix: matrix inColumn: (int)col
{int i, n;
  n=0;
  switch (col) {
    case 0:
      for (i=0; i<4; i++) {
        [matrix addRow];
        [[matrix cellAt: i: 0] setLeaf: NO];
        [[matrix cellAt: i: 0] setLoaded: YES];
        [[matrix cellAt: i: 0] setEnabled: YES];
        }
      [[matrix cellAt: 0: 0] setStringValue: "operators"];
      [[matrix cellAt: 1: 0] setStringValue: "predefined"];
      [[matrix cellAt: 2: 0] setStringValue: "demonstrations"];
      [[matrix cellAt: 3: 0] setStringValue: "reversibles"];
      n=4;
      break;
    case 1:
      if (strcmp([[sender selectedCell] stringValue],"reversibles")==0) {
	for (i=0; i<47; i++) {
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: revrule[i]];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=47;} 
      if (strcmp([[sender selectedCell] stringValue],"demonstrations")==0) {
	for (i=0; i<NY; i++) {
	  [matrix addRow];
      	  [[matrix cellAt: i: 0] setStringValue: recrule[i]];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=NY;} 
      if (strcmp([[sender selectedCell] stringValue],"predefined")==0) {
	for (i=0; i<1; i++) {
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: idef[i]];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=1;}
      if (strcmp([[sender selectedCell] stringValue],"operators")==0) {
	for (i=0; i<95; i++) {
          printf("dtbl[%d]=%s\n",i,dtbl[i].r_cmnt);
	  [matrix addRow];
	  [[matrix cellAt: i: 0] setStringValue: dtbl[i].r_cmnt];
	  [[matrix cellAt: i: 0] setLeaf: YES];
	  [[matrix cellAt: i: 0] setLoaded: YES];
	  [[matrix cellAt: i: 0] setEnabled: YES];
	  }
	n=95;}
      break;
    default: n=0; break;}
return n;
}

/* - - - - - - - -   F I L E   A N D   D I R E C T O R Y   - - - - - - - - */

- setFilename:(const char *)aFilename
{
if (filename) free(filename);
filename = malloc(strlen(aFilename)+1);
strcpy(filename, aFilename);
[window setTitleAsFilename:aFilename];
return self;
}



- open:sender
{
  char *types[2] = {"rec",0};
  int  i, fd;
  NXStream *theStream;

printf("hello from open\n");
  [[OpenPanel new] allowMultipleFiles: NO];
  [[OpenPanel new] chooseDirectories: NO];

  if ([ [OpenPanel new] runModalForTypes:types]) {
    [self setFilename: [[OpenPanel new] filename]];
    fd = open(filename, O_RDONLY, 06666);
    theStream = NXOpenFile(fd, NX_READONLY);
//      NXScanf(theStream,"%s",cstr);
      i=0;
      while (NXScanf(theStream,"%c",&cstr[i])!=EOF) i++;
      phil=strlen(cstr);
    NXClose(theStream);
    close(fd);
    [window setTitleAsFilename: filename];
    [window setDocEdited:NO];
  [xtrnWin setSel: 0: [xtrnWin textLength]];
  [xtrnWin replaceSel: cstr];
  [xtrnWin scrollSelToVisible];
  [xtrnWin display];
    }

  return self;
}




- saveAs:sender
{
  id panel;
  const char *dir;
  char *file;

/* prompt user for the file name and save to that file */

  if (filename==0) {
    /* no filename; set up defaults */ 
    dir  = NXHomeDirectory();
    file = (char *)[window title];
    } else {
    file=rindex(filename,'/');
    if (file) {
      dir   = filename;
      *file = 0;
      file++;
      } else {
      dir  = filename;
      file = (char *)[window title];
      }
    }
  panel = [SavePanel new]; 
  [panel setRequiredFileType: ""];
  if ([panel runModalForDirectory: dir file: file]) {
    [self setFilename: [panel filename]];
    return [self save: sender];
    }
    return nil;  /* didn't save */
  }
    
- save:sender
{
  int      fd;
  NXStream *theStream;

  if (filename==0) return [self saveAs: sender];
  [window setTitle: "Saving ..."];

  fd = open(filename, O_WRONLY | O_CREAT | O_TRUNC, 06666);
  if (fd < 0) {
    NXRunAlertPanel(0, "Cannot save file: %s",0,0,0,strerror(errno));
    return self;
    }
  theStream = NXOpenFile(fd, NX_WRITEONLY);
  [xtrnWin writeText: theStream];
  NXClose(theStream);
  close(fd);
  [window setTitleAsFilename: filename];
  [window setDocEdited:NO];
  return self;
}

- close:sender 
{const char *fname;
int         q;
  if ([window isDocEdited])
//    fname=filename ? filename : [sender title];
//    if (rindex(fname,'/')) fname = rindex(fname,'/') + 1;
    q = NXRunAlertPanel(
      "Save",
      "Save changes to %s?",
      "Save",
      "Don't Save",
      "Cancel",
      filename);
    if (q==1) {if (![self save:nil]) return nil;}
    if(q==-1) return nil;
//  [sender setDelegate: nil];
//  [proc free];
//  [self free];
  return self;
}

- windowWillClose:sender
{
[self close: self];
printf("windowWillClose\n");
return self;
}



/* - - - - - - -  R E C   P R O G R A M   M A N A G E M E N T - - - - - - - */

- loadInternal:sender 
{
  [self loadLowerPanel: internalRECBox];
return self;
}

- loadExternal:sender 
{
  [self loadLowerPanel: externalRECBox];
return self;
}

- loadLowerPanel:thisRECBox 
{NXRect bxRect, loRect;
  [theBigBox getFrame: &bxRect];
  [thisRECBox getFrame: &loRect];
  [theLilBox setContentView: [thisRECBox contentView]];
  loRect.origin.x=(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=(bxRect.size.height-loRect.size.height)/2.0;
  [theLilBox setFrame: &loRect];
  [theBigBox display];
  [theLilBox display];
return self;
}





/* - - - - - - - - - - -  R E C   p r o g r a m s   - - - - - - - - - - */

- doRec:sender 
{
  [value setStringValue: " "];
  if (rec([sender stringValue])) 
	[value setStringValue: "T"]; else [value setStringValue: "F"];
return self;
}

- copyAndRunREC:sender 
{
  [value setStringValue: " "];
  [execWin setStringValue: [[sender selectedCell] stringValue]];
  if (rec([execWin stringValue])) 
	[value setStringValue: "T"]; else [value setStringValue: "F"];
return self;
}

- runREC:sender 
{
  [value setStringValue: " "];
  [value setStringValue: (rec(cstr))?"T":"F"];
return self;
}

- rerunREC:sender 
{
  [xtrnWin getSubstring: cstr start: 0 length: [xtrnWin textLength]];
  [window setDocEdited:YES];
return self;
}

int rec(z) char *z; {if (rec_c(z,rprg,PLEN,dtbl)==1) rec_x(rprg);}

@end

/* end GrabBag.m */