/* 
 * LiulGuph.h -- Interface file for the LiulGuph class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use.
 *
 */

#import <appkit/appkit.h>
#import <appkit/NXCType.h>

@interface LiulGuph:View
{

	id		gen2;
	id		gen3;
	id		gen4;
	id		gen5;
	id		gen6;

	id		treeShow;

	id		constBox;
	id		dbBranches;
	id		evWindow;
	id		evButton;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		rijnBigBox;
	id		rijnLilBox;
	id		shiftBox;
	id		widBox;
	id		bouBox;
	id		capBox;
	id		lblBox;
	id		dblBox;

	id		ruleNumber;
	id		underDiagram;
	id		whichConstant;
	id		whichPermutation;
	id		whichShift;

	id		sparePanel;
	id		spareView;
	id		timeDate;
	id		wholePanel;
	
	id		delegate;
	id		points;
	id		crossCursor;
}

- basicRijn:sender;
- loadDiagramType:sender;
- loadParamValues:sender;
- loadSelectionPanel:sender;
- printBasic:sender;
- printGeneric:sender;
- printRijn:sender;
- rijn:sender;
- rijnConst:sender;
- rijnHowBig:sender;
- rijnRanSam:sender;
- rijnReset:sender;
- shewRijn:sender;
- Zot:sender;


- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

