
#import <appkit/appkit.h>

@interface RulePanel:View
{

/* panel control - - - - - - - - - - - - - - - - - - - - - - - - */
	id		eaterRuleBox;
	id		emulRuleBox;
	id		equivRuleBox;
	id		prodRuleBox;
	id		specBigBox;
	id		specLilBox;
	id		subsetRuleBox;
	id		arithmRuleBox;

/* Main Panel  - - - - - - - - - - - - - - - - - - - - - - - - - */
	id		ascru;         /* = */
	id		changeLine;    /* = */
	id		pSliders;      /* = */
	id		pWindows;      /* = */
	id		ruleNumber;    /* = */
	id		totlRef;       /* = */
	id		sIncr;         /* = */
	id		tiDat;         /* = */
	id		wrule;         /* = */

/* de Bruijn Window  - - - - - - - - - - - - - - - - - - - - - - */
	id		gfWindow;      /* = */
	id		ruleFormula;   /* - */

/* eater rule   - - - - - - - - - - - - - - - - - - - - - - - - */
	id		eatingCell;

/* cartesian product  - - - - - - - - - - - - - - - - - - - - - */
	id		the2hFact;
	id		the3hFact;
	id		the2hRule;
	id		the3hRule;
	id		the3HRule;

/* emulation Window   - - - - - - - - - - - - - - - - - - - - - */
	id		ruleMatrix;
	id		the21Panel;
	id		the21Text;

/* totalistic Window  - - - - - - - - - - - - - - - - - - - - - */
	id		toRuleNumber;  /* = */
	id		toWindow;      /* = */

/* clannish Window  - - - - - - - - - - - - - - - - - - - - - */
	id		sub2h;

/* equivalence Box  - - - - - - - - - - - - - - - - - - - - - - */
	id		eqChoices;     /* - */
	id		eqFactor;      /* - */
	id		eqPair;        /* - */

/* arithmetic Box   - - - - - - - - - - - - - - - - - - - - - - */
	id		twoRules;      /* = */


/* trivia Panel    - - - - - - - - - - - - - - - - - - - - - - */
	id		statEntro;     /* = */
        id		statPEntro;    /* = */
	id		statIndx;      /* = */
	id		statLamb;      /* = */
	id		statPairs;     /* = */
	id		statState;     /* = */
	id		statXeno;      /* = */

/* design Window  - - - - - - - - - - - - - - - - - - - - - - - */
	id		ddWindow;      /* - */
	id		designPrm;     /* = */
	id		designRef;     /* = */
	id		zeZeZe;        /* = */


/* ----------    REC line from RulePanel --------*/	
	id		RECline;       /* + */
	id		RECPanel;      /* + */
	id		RECValue;      /* + */


}

- loadSpecialRule:sender;
- loadLowerPanel:thisRuleBox;

- freeAllRules:sender;        /* = */
- insertRule:sender;
- protectGenRule:sender;      /* = */
- ranRules:sender;            /* = */
- ranPRules:sender;           /* = */
- randomLine:sender;
- relatedRule:sender;         /* = */
- readWRule:sender;           /* = */
- sCellLine:sender;           /* - */
- setAllRules:sender;         /* = */
- setDemo:sender;             /* = */
- setRule:sender;             /* = */
- showProbability:sender;     /* = */
- symRule:sender;             /* = */
- uniformLine:sender;
- zeroRules:sender;           /* = */

- eaterRule:sender;

/* cartesian product  - - - - - - - - - - - - - - - - - - - - - */
- cartProd:sender;
- rand2h:sender;
- rand3h:sender;
- read2hFact:sender;
- read3hFact:sender;
- read2hRule:sender;
- read3hRule:sender;
- read3HRule:sender;
- setCartUp:sender;
- enterEmul:sender;

/* emulation Window   - - - - - - - - - - - - - - - - - - - - - */
- read21Text:sender;
- read21Panel:sender;
- readEmul:sender;
- setEmulUp:sender;

/* totalistic Window  - - - - - - - - - - - - - - - - - - - - - */
- enterTotalisticRule:sender;
- setTotalisticState:sender;

- equivalence:sender;          /* - */
- ranqul:sender;               /* - */

/* ----------    arithmRulebox   ------------ */
- arithmCombs:sender;          /* = */
- initTwoRules:sender;         /* = */

- randphobic:sender;
- xenophilic:sender;
- xenophobic:sender;
- enterPair:sender;

- clearDesign:sender;          /* = */
- copyToDesign:sender;         /* = */
- deZign:sender;               /* = */
- enterDesign:sender;          /* = */

- nxasfreq;                    /* = */

@end 

/* end RulePanel.h */ 
