/* 
 * SusetView.h -- Interface file for the SusetView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use.
 *
 */

#import <appkit/appkit.h>
#import <appkit/NXCType.h>

@interface SusetView:View
{


	id		treeShow;
	id		evWindow;
	id		evButton;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		ruleNumber;

	id		suTriv1;
	id		suTriv2;

	id		susetWindow;
	id		wholePanel;
	id		timeDate;
	
	id		delegate;
	id		crossCursor;
}

- showSubset:sender;
- drawSubset:sender;
- prepareSubset:sender;
- printSubset:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;
- (const char *)inspectorName;
@end
