
/* lcau51.h		*/
/* header for lcau51.c	*/
/* 12 May 1989		*/

# define COLGRAF      4  /* graph resolution			*/
# define T80X25       3  /* text resolution			*/
# define TRR	     16  /* row showing totalistic rule number	*/
# define TRC	     56  /* column for totalistic rule number	*/
# define XRR	     12  /* row displaying totalistic rule	*/
# define XRC	     56  /* column for totalistic rule		*/
# define WHCYMAG      1  /* color quad for normal screen	*/
# define YELREGR      2  /* color quad for alternative		*/
# define AL         320  /* array length (screen width)		*/
# define SL	     40	/* short array length			*/
# define KK	      5  /* number of states per cell		*/
# define RR	      3  /* length of neighborhood = 2r+1	*/ 
# define DS    KK*KK*KK  /* 2^RR (distinct neighborhoods)	*/
# define TS RR*(KK-1)+1  /* distinct sums w/totalistic rule	*/

/* end */